package papi;

import static papi.Papi4J.doOrCry;

public class EventSet {

	public int set;
	public PapiJ pj = null;
	public int eventCount = 0;
	
	public long[] readBuffer;
	
	public void setPapiJ(PapiJ pj) {
		this.pj = pj;
	}
	
	public void start() {
		doOrCry(pj.start(this),
				"PAPI_start"); 
	}
	
	public long[] stop () {
		long[] ret = new long[eventCount];
		doOrCry(pj.stop(this, ret),
				"PAPI_stop");
		return ret;
	}
	
	public void cleanUp() {
		doOrCry(pj.cleanup_eventset(this),
				"cleanup_eventset");
	}
	
	public void destroy() {
		doOrCry(pj.destroy_eventset(this), 
			    "PAPI_destroy_eventset");
	}
	
	public void assignComponent(int cidx) {
		doOrCry(pj.assign_eventset_component(this, cidx),
				"Failed to assign_eventset_component");
	}
	
	public void attach (int pid) {
		doOrCry(pj.attach(this, pid),
			    "Failed to attach to child");
	}
	
	public void addEvent (int event) {
		doOrCry(pj.add_event(this,  event),
				"Failed to add event to event set");
		eventCount++;
	}
	
	public void accum (long[] values) {
		doOrCry(pj.accum(this, values),
				"Failed to accum values");		
	}
	
	
	
	public long[] read () {
		long[] values = new long[eventCount];
		doOrCry(pj.read(this, values), "Failed to read counters");
		return values;		
	}
	
	public long[] readAndReset() {
		long[] values = new long[eventCount];
		accum(values);
		return values;
	}
	
}
